local APH = LibStub("AceAddon-3.0"):NewAddon("APH", "AceConsole-3.0", "AceEvent-3.0")
local _,APHdata = ...



local AceGUI = LibStub("AceGUI-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")

local _G = getfenv(0)

local APHMainFrame
local APHInfoFrame
local ArtPow = {}
local TotalArtifactPower = 0
local APHArtifactItems = {}
local db
local dbc

local _,class= UnitClass("PLAYER")

local PName, PRealm = UnitName("PLAYER")


local msq, msqGroups = nil, {}
if LibStub then
	msq = LibStub("Masque",true)
	if msq then
		msqGroups = {
			APHItems = msq:Group("Artifact Power Helper", "Items"),
			APHWeapons = msq:Group("Artifact Power Helper", "Weapons"),
		}
	end
end

local defaults = {
    profile = {
		MainPosX = UIParent:GetWidth() / 2,
		MainPosY = UIParent:GetHeight() / 2,
		Minimized = false,
		--bgColor = {r=0.0,g=0.0,b=0.0,a=0.5},
		bgColor =  {r=0, g=0, b=0, a=0.5 },

    },
	char = {
		ArtifactWeapons={}
	}
	
}
for _,i in ipairs(APHdata.ArtifactWeapons[class]) do
	defaults.char.ArtifactWeapons[i] = {nil,nil,nil} --{curAP,curPoints,toNext}
end

local options = {
    name = "Artifact Power Helper",
    handler = APH,
    type = 'group',
    args = {
		backgroundColorPicker = {
			type = 'color',
			name = 'Choose Background Color',
			hasAlpha = true,
			get = function()
				return db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a
			end,
			set = function(_, r, g, b, a)
				db.bgColor.r = r
				db.bgColor.g = g
				db.bgColor.b = b
				db.bgColor.a = a
				APH:SetBackground()
			end,
			},
		},
}


function APH:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("APHDB", defaults, true)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("ArtifactPowerHelper", options)
	--self:UpdateOptions()
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ArtifactPowerHelper", "Artifact Power Helper")
	db = self.db.profile
	dbc = self.db.char
	
	APH.PosX = db.MainPosX
	APH.PosY = db.MainPosY
	APH.Minimized = db.Minimized
	--APH:Print(APH.PosX, APH.PosY)
	APHMainFrame:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",APH.PosX,APH.PosY)
	APH:RegisterEvent("ADDON_LOADED")
	APH:RegisterEvent("PLAYER_REGEN_DISABLED")
	APH:RegisterEvent("PLAYER_REGEN_ENABLED")
	--APH:RegisterEvent("UNIT_INVENTORY_CHANGED")
	APH:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
	--APH:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	--APH:RegisterEvent("UNIT_AURA")
	--APH:RegisterEvent("BAG_UPDATE")
	APH:RegisterEvent("PLAYER_ENTERING_WORLD")
	APH:RegisterEvent("ARTIFACT_XP_UPDATE")
	APH:RegisterChatCommand("aph", "aph")
	APH:RegisterChatCommand("aphh","Hide")
	
	
	
end
	--[[##########TIMER FUNCTION##############]]--
	local timerFrame = CreateFrame("Frame")
	timerFrame:Hide()
	local delay = 0
	timerFrame:SetScript('OnUpdate', function(self, elapsed)
	  delay = delay - elapsed
	  if delay <= 0 then
		APH:PreUpdate()
		self:Hide()
	  end
	end)
	timerFrame:SetScript('OnEvent', function(self)
	  delay = 0.5
	  self:Show()
	end)
	timerFrame:RegisterEvent('BAG_UPDATE')	


 
function APH:Hide()
	APHMainFrame:Hide()
end


function APH:aph(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory("Artifact Power Helper")
        InterfaceOptionsFrame_OpenToCategory("Artifact Power Helper")
    end
	---APH:UpdateWeapons()
end

function APH:setBGColors(r,g,b,a)
--APH:Print('r',r,'g',g,'b',b,'a',a)
for i, j in ipairs(r) do APH:Print(i,j) end
APH:Print(unpack(r))
	--self.db.profile.bgColor = {value.r, value.g, value.b,	value.a}
	--APH:PreUpdate(true)
end

function APH:getBGColors()
--return unpack(db.healthColor)
	APH:Print( unpack(db.bgColor))
	return db.bgColor
end



function APH:HideTT()
	GameTooltip_Hide()
end
function APH:ShowTT(id)
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	GameTooltip:SetItemByID(id)
	GameTooltip:Show()
end

function table.contains(table, element,index)
  for i, value in pairs(table) do
    if value[index] == element then
      return i
    end
  end
  return false
end

local function ReadableNumber(num, places)
    local ret
    local placeValue = ("%%.%df"):format(places or 0)
    if not num then
        return 0
    elseif num >= 1000000000000 then
        ret = placeValue:format(num / 1000000000000) .. " T" -- trillion
    elseif num >= 1000000000 then
        ret = placeValue:format(num / 1000000000) .. " B" -- billion
    elseif num >= 1000000 then
        ret = placeValue:format(num / 1000000) .. " M" -- million
    elseif num >= 1000 then
        ret = placeValue:format(num / 1000) .. "K" -- thousand
    else
        ret = num -- hundreds
    end
    return ret
end


function APH:FindItemInBags(ItemID)
	local NumSlots
	for Container = 0, NUM_BAG_SLOTS do
		NumSlots = GetContainerNumSlots(Container)
		if NumSlots then
			for Slot = 1, NumSlots do
				if ItemID == GetContainerItemID(Container, Slot) then
					return Container, Slot
				end
			end
		end
	end
	return false
end

local inBank = false
function APH:GetInventoryItems()
	local TotalArtifactPower=0
	local ArtPow = {}
	
	for bag = 0, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
			id = GetContainerItemID(bag, slot)
			a = GetItemSpell(id)
			if a=="Empowering" then
				newItemAP=APH:ReadAP(id) or 0
				conf=table.contains(ArtPow,id,1)
				if conf then
					if newItemAP == ArtPow[conf][2] then
						ArtPow[conf][3]=ArtPow[conf][3]+1
					else
						--
					end
				else
				--APH:Print(id, newItemAP)
					tinsert(ArtPow,{id,newItemAP,1})
				end
				--tinsert(ArtPow,tmp)
				TotalArtifactPower = TotalArtifactPower + newItemAP
			end
        end
    end
	sort(ArtPow,function(a,b) return a[2]>b[2] end)
	
	return ArtPow, TotalArtifactPower
end

function APH:CreateArtifactItems()
	for i=1, 55, 1 do
		local items = CreateFrame("Button","ArtPowerItem"..i,ArtifactPowerFrame,"SecureActionButtonTemplate")
			items:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
			items:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]],"ADD")

			--items:SetSize(36,36)
			items:SetHeight(32)
			items:SetWidth(32)
			items.Icon=items:CreateTexture(nil,"BACKGROUND")
			--texture=select(10, GetItemInfo(id))
			items.Icon:SetAllPoints(items)
			--items.Icon:SetTexture(texture)
			--items:SetPoint("TOPLEFT",ArtifactPowerFrame,"TOPLEFT", (i-1)*36, 0)
			
			--items:SetScript("OnEnter", function() APH:ShowTT(id) end)
			--items:SetScript("OnLeave", function() APH:HideTT() end)
			items.Count = items:CreateFontString("Count"..i,"ARTWORK","NumberFontNormal")
			items.Count:SetJustifyH("RIGHT")
			items.Count:SetPoint("BottomRight",-2,2)

			items.AP = items:CreateFontString("AP"..i,"ARTWORK","NumberFontNormal")
			items.AP:SetJustifyH("LEFT")
			items.AP:SetPoint("TOPLEFT")
			
			items:RegisterForClicks("AnyUp")
			items:SetAttribute("type","item")
			
			if msqGroups["APHItems"] then msqGroups.APHItems:AddButton(items) end

		tinsert(APHArtifactItems,items)
	end	
	return APHArtifactItems
end

function APH:GetArtifactButtons(id)
	if APHArtifactItems[id] then return APHArtifactItems[id] end

	local items = CreateFrame("Button","ArtPowerItem"..id,ArtifactPowerFrame,"SecureActionButtonTemplate")
	items:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
	items:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]],"ADD")
	items:SetHeight(32)
	items:SetWidth(32)
	items.Icon=items:CreateTexture(nil,"BACKGROUND")
	items.Icon:SetAllPoints(items)
	items.Count = items:CreateFontString("Count"..i,"ARTWORK","NumberFontNormal")
	items.Count:SetJustifyH("RIGHT")
	items.Count:SetPoint("BottomRight",-2,2)
	items.AP = items:CreateFontString("AP"..i,"ARTWORK","NumberFontNormal")
	items.AP:SetJustifyH("LEFT")
	items.AP:SetPoint("TOPLEFT")
	items:RegisterForClicks("AnyUp")
	items:SetAttribute("type","item")
	
	if msqGroups["APHItems"] then msqGroups.APHItems:AddButton(items) end

	tinsert(APHArtifactItems,items)
	return items
end


local Weapons = {}
function APH:CreateWeaponsIcons()
	for ct,weapon in ipairs(APHdata.ArtifactWeapons[class]) do
		local WeaponIcon=CreateFrame("Button","ArtifactWeapon"..ct,ArtifactInfoFrame,"SecureActionButtonTemplate")
			WeaponIcon:SetSize(40,40)
			WeaponIcon:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
			WeaponIcon:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]],"ADD")
			--WeaponIcon:SetButtonState("PUSHED",true)
			--if C_ArtifactUI.GetEquippedArtifactInfo()==weapon then ActionButton_ShowOverlayGlow(WeaponIcon) end
			--local icon= select(10,GetItemInfo(weapon))
			WeaponIcon.Icon=WeaponIcon:CreateTexture(nil, "BACKGROUND")
			--WeaponIcon.Icon:SetTexture(icon)
			WeaponIcon.Icon:SetAllPoints(WeaponIcon)
			--WeaponIcon:SetPoint("TOPLEFT",ArtifactInfoFrame,"TOPLEFT",60*ct,0)
			--WeaponIcon:SetScript("OnEnter", function() APH:ShowTT(weapon) end)
			--WeaponIcon:SetScript("OnLeave", function() APH:HideTT() end)
			WeaponIcon.Percent = WeaponIcon:CreateFontString("Percent","ARTWORK","NumberFontNormal")
			WeaponIcon.Percent:SetFont("Fonts\\FRIZQT__.TTF", 12, "THICKOUTLINE")
			WeaponIcon.Percent:SetJustifyH("CENTER")
			WeaponIcon.Percent:SetJustifyV("MIDDLE")
			WeaponIcon.Percent:SetPoint("CENTER",2,0)

			tinsert(Weapons,WeaponIcon)
			if msqGroups["APHWeapons"] then msqGroups.APHWeapons:AddButton(WeaponIcon) end
	end
	--MinimizedWeapons=Weapons[1]
end



local tip = CreateFrame ("GameTooltip", "APHTooltipReader", nil, "GameTooltipTemplate")
function APH:ReadAP (itemLink)
	tip:SetOwner (WorldFrame, "ANCHOR_NONE")
	tip:SetItemByID (itemLink)

	for i=tip:NumLines(),1,-1 do
		local txt=_G["APHTooltipReaderTextLeft"..i]:GetText()
	  if txt and string.match(string.gsub(txt,"%p",""),"Use Grants (%d+) Artifact Power") then
		--APH:Print(txt,string.match(string.gsub(txt,"%p",""),"Use Grants (%d+) Artifact Power"))
		power=string.match(string.gsub(txt,"%p",""),"Use Grants (%d+) Artifact Power")
		return tonumber(power)
	  end
	end	
end

local function CalcPercent(rank,totalAP)
if not rank or rank == nil then return 0 end
if not totalAP or totalAP == nil then return 0 end
	local ret, ranksGained = _,0
	local cost = APHdata.ArtifactCosts[rank]
	local InitialRank=rank
	if(cost < totalAP) then
		repeat
			rank = rank + 1
			newCost=APHdata.ArtifactCosts[rank]
			totalAP = totalAP - cost
			cost = newCost
		until cost > totalAP or rank > 34
		ranksGained = rank - InitialRank
	end
	ret = totalAP/cost


	return math.floor( (ret + ranksGained)*100)
end

local CostOfNext, CurPow, Equipped, CurRank = 0,0,0,0

function APH:UpdateWeapons2()
	local UnlockedWeapons = {}
	Equipped,_,_,_,CurPow, CurRank = C_ArtifactUI.GetEquippedArtifactInfo()
	CurPow, CurRank = CurPow or 0, CurRank or 0
	CostOfNext = C_ArtifactUI.GetCostForPointAtRank(CurRank or 0)
	--APH:Print(CurPow, CurRank, CostOfNext)
	tinsert(UnlockedWeapons,Equipped)
	--APH:Print(Equipped)
	for _,weapon in ipairs(APHdata.ArtifactWeapons[class]) do
		if APH:FindItemInBags(weapon) then
			tinsert(UnlockedWeapons,weapon)
		end
	end
	--APH:Print("Number of unlocked",#UnlockedWeapons)
	local nW = #UnlockedWeapons
	--APH:Print(APHdata.WC[nW].OffSet,APHdata.WC[nW].Spacing)
	for i, j in ipairs(UnlockedWeapons) do
		local weap = Weapons[i]
		texture = select(10, GetItemInfo(j) )
		weap.Icon:SetTexture(texture)
		if i==1 then -- Equipped Weapon
			local Percent = CalcPercent(CurRank +1, CurPow + TotalArtifactPower)
			weap.Percent:SetText(Percent.."%")
			if Percent>=100 then
				ActionButton_ShowOverlayGlow(weap)
			else
				ActionButton_HideOverlayGlow(weap)
			end
		else
			weap:SetButtonState("PUSHED",true)
		end
		--weap:SetScript("OnEnter", function() APH:ShowTT(j) end)
		--weap:SetScript("OnLeave", function() APH:HideTT() end)

		weap:SetPoint("TOPLEFT",ArtifactInfoFrame,"TOPLEFT",APHdata.WC[nW].OffSet+(40+APHdata.WC[nW].Spacing)*(i-1),-30)
	end
end
--APH:UpdateWeapons()	

function APH:UpdateWeapons()
--APH:Print("updateweapons2")
local unlocked = {}
Equipped = C_ArtifactUI.GetEquippedArtifactInfo() or 0
tinsert(unlocked,Equipped)
for _, i in ipairs(APHdata.ArtifactWeapons[class]) do
	if APH:FindItemInBags(i) then tinsert(unlocked,i) end
end
local nW = #unlocked
_,_,_,_,CurPow, CurRank = C_ArtifactUI.GetEquippedArtifactInfo()
CurPow, CurRank = CurPow or 0, CurRank or 0
CostOfNext = C_ArtifactUI.GetCostForPointAtRank(CurRank)
self.db.char.ArtifactWeapons[Equipped] = {CurRank,CurPow,CostOfNext}
local saved = self.db.char.ArtifactWeapons
if not saved[unlocked[1]] then return end

for i,j in ipairs(unlocked) do
		local weap = Weapons[i]
		texture = select(10, GetItemInfo(j) )
		weap.Icon:SetTexture(texture)
	if saved[j] and saved[j][1] then
		local CR, CP, CN = saved[j][1],saved[j][2],saved[j][3]
		local Percent = CalcPercent(CR +1, CP + TotalArtifactPower)
		if Percent>=100 then
			--ActionButton_ShowOverlayGlow(weap)
			weap.Percent:SetText(math.floor(Percent/100) .."\nPts")
		else
			--ActionButton_HideOverlayGlow(weap)
			weap.Percent:SetText(Percent.."%")
		end
	end
		weap:SetPoint("TOPLEFT",ArtifactInfoFrame,"TOPLEFT",APHdata.WC[nW].OffSet+(40+APHdata.WC[nW].Spacing)*(i-1),-30)
end

APHMinimizedFrame.Icon.Texture:SetTexture(select(10,GetItemInfo(unlocked[1])))
		local Percent = CalcPercent(CurRank +1, CurPow + TotalArtifactPower)
		if Percent>=100 then
			--ActionButton_ShowOverlayGlow(weap)
			APHMinimizedFrame.Icon.Percent:SetText(math.floor(Percent/100) .."\nPts")
		else
			--ActionButton_HideOverlayGlow(weap)
			APHMinimizedFrame.Icon.Percent:SetText(Percent.."%")
		end


end



function APH:Update()
	--ArtPow={}
	--ArtPow, TotalArtifactPower=APH:GetInventoryItems()
	for _,t in ipairs(APHArtifactItems) do t.Icon:SetTexture(0,0,0,1); t:Hide() end
	local itemsNum=table.getn(ArtPow)
	--APH:Print(itemsNum)
	--local dimW, dimH = 220, 100
	--APHMainFrame:SetSize(dimW, dimH)
	local j=1
	for i, ids in ipairs(ArtPow) do
	--APH:Print("Update:",ids)
		--local button = APH:CreateArtifactItems(ids.id)
		--local button = APHArtifactItems[j]
		local button = APH:GetArtifactButtons(j)
		--APH:Print(button)
		texture = select(10, GetItemInfo(ids[1]) )
		button.Icon:SetTexture(texture)
		button:SetScript("OnEnter", function() APH:ShowTT(ids[1]) end)
		button:SetScript("OnLeave", function() APH:HideTT() end)
		button:SetAttribute("item","item:"..ids[1])
		local col, row = (j-1) - math.floor((j-1)/6)*6, math.floor((j-1)/6)
		button:SetPoint("TOPLEFT", ArtifactPowerFrame,"TOPLEFT", 4+col*36,-90-row*36)
		
		button.Count:SetText(ids[3])
		button.AP:SetText("|c0000ff00"..ReadableNumber(ids[2],2).."|r")
		
		button:Show()
		j=j+1
	end
	--APH:Print(90+(math.floor(#ArtPow/6)+1)*36,#ArtPow)
	APHMainFrame:SetHeight(90+math.floor((#ArtPow+5)/6)*36)
	if msqGroups["APHItems"] then
		msqGroups.APHItems:ReSkin()
		msqGroups.APHWeapons:ReSkin()
	end
	--APH:Print(i)
	APH:UpdateWeapons()
	APH:UpdateTexts()
end


function APH:PreUpdate(force)
--APH:Print(force or "No arguments")
local newAP, newTotal = APH:GetInventoryItems()
if newTotal == 0 and not APH.Minimized then APH:Minimize() end
if #newAP ~= #ArtPow or newTotal ~=TotalArtifactPower or force then
	--APH:Print("Values Changed. Updating")
	ArtPow=newAP
	TotalArtifactPower=newTotal
	APH:Update()
else
	--APH:Print("Nothing Changed")
end
end

function APH:WeaponsChanged()

end

function APH:Minimize()
	if APH.Minimized then
		APHMinimizedFrame:Hide();
		APHMinimizedFrame.Maxi:Hide()
		APHMainFrame:Show();
		APH.Minimized = not APH.Minimized
	else
		APHMainFrame:Hide();
		APHMinimizedFrame:Show();
		APH.Minimized = not APH.Minimized
	end
	APH.db.profile.Minimized = APH.Minimized
end



function APH:PLAYER_EQUIPMENT_CHANGED(slot,hasItem)
--APH:Print("PLAYER_EQUIPMENT_CHANGED",slot,hasItem)
if slot == 16 or 17 then
--APH:Print("Weapons Changed")
APH:UpdateWeapons()
APH:Update()

end
end


function APH:PLAYER_REGEN_DISABLED()
	timerFrame:UnregisterEvent("BAG_UPDATE")
	APHMainFrame:Hide()
	APHMinimizedFrame:Hide();
end

function APH:PLAYER_REGEN_ENABLED()
	timerFrame:RegisterEvent("BAG_UPDATE")
	if APH.Minimized then
		APHMinimizedFrame:Show();
	else
		APHMainFrame:Show()
	end
	APH:PreUpdate()
end

function APH:BAG_UPDATE()
--APH:Print("BAG_UPDATE")	
	APH:PreUpdate()
end

function APH:PLAYER_ENTERING_WORLD()
--APH:Print("PLAYER_ENTERING_WORLD")	
	APH:PreUpdate(true)
APH.Minimized = not APH.Minimized
APH:Minimize()

end

function APH:ADDON_LOADED()
	APH:SetBackground()
end

function APH:PLAYER_LOGIN()
	--if UnitLevel("PLAYER")<100 then APH:Disable() end
end

function APH:ARTIFACT_XP_UPDATE()
--APH:Print("ARTIFACT_XP_UPDATE")
	APH:PreUpdate(1)
end

function APH:BANKFRAME_OPENED()
	inBank = true
end

function APH:BANKFRAME_ClOSED()
	inBank = false
end



function APH:StopMoving()
local bottom
	if APH.Minimized then
		APHMinimizedFrame:StopMovingOrSizing()
		left, bottom = APHMinimizedFrame:GetLeft(), APHMinimizedFrame:GetBottom() + APHMinimizedFrame:GetHeight()
		APHMainFrame:SetPoint("TOPLEFT", UIParent,"BOTTOMLEFT", left, bottom)
	else
		APHMainFrame:StopMovingOrSizing()
		left, bottom = APHMainFrame:GetLeft(), APHMainFrame:GetBottom() + APHMainFrame:GetHeight()
		APHMinimizedFrame:SetPoint("TOPLEFT", UIParent,"BOTTOMLEFT", left, bottom)
	end

	APH.db.profile.MainPosX = APHMainFrame:GetLeft()
	APH.db.profile.MainPosY = bottom --APHMainFrame:GetBottom() + APHMainFrame:GetHeight()
end

function APH:SetBackground()
--db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a
APHMainFrame.texture:SetColorTexture(db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a)
APHMinimizedFrame.texture:SetColorTexture(db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a)
end


APHMainFrame = CreateFrame("Frame", "ArtifactPowerFrame", UIParent)
    APHMainFrame:SetSize(220, 20)
	--APHMainFrame:SetScale(2)
	APHMainFrame:SetFrameStrata("BACKGROUND")
--[[	APHMainFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", --Set the background and border textures
	edgeFile = nil,-- "Interface/Tooltips/UI-Tooltip-Border", 
	tile = true, tileSize = 16, edgeSize = 16, 
	insets = { left = 0, right = 0, top = 0, bottom = 0 }
})
	APHMainFrame:SetBackdropColor(0, 0, 0) --Set the background colour to black]]--
	APHMainFrame.texture = APHMainFrame:CreateTexture(nil, "BACKGROUND")
	--APHMainFrame.texture:SetColorTexture(0,0,0,.5)
	APHMainFrame.texture:SetAllPoints()
    APHMainFrame:SetPoint("TOPLEFT", UIParent,"BOTTOMLEFT", APH.PosX,APH.PosY)
    APHMainFrame:SetMovable(true)
    APHMainFrame:SetClampedToScreen(true)
	APHMainFrame:SetDontSavePosition(true)
	APHMainFrame:EnableMouse(true)
	APHMainFrame:RegisterForDrag("LeftButton")
	APHMainFrame:SetScript("OnDragStart", APHMainFrame.StartMoving)
	APHMainFrame:SetScript("OnDragStop", function () APH:StopMoving() end)
	APHMainFrame:SetScript("OnEnter", function() APHMainFrame.Mini:Show() end)
	APHMainFrame:SetScript("OnLeave", function() APHMainFrame.Mini:Hide() end)
	APHMainFrame:SetHitRectInsets(0, -19, 0, 0)
	
	APHMainFrame.Mini = CreateFrame("Button","Minimize",APHMainFrame,"SecureActionButtonTemplate")
	APHMainFrame.Mini:SetSize(24,24)
	APHMainFrame.Mini.Texture=APHMainFrame.Mini:CreateTexture(nil,"BACKGROUND")
	APHMainFrame.Mini.Texture:SetAllPoints()
	APHMainFrame.Mini:SetPoint("TOPRIGHT",APHMainFrame,19,5)
	APHMainFrame.Mini:SetNormalTexture([[Interface\Buttons\UI-Panel-SmallerButton-Up]])
	APHMainFrame.Mini:SetPushedTexture([[Interface\Buttons\UI-Panel-SmallerButton-Down]])
	APHMainFrame.Mini:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]],"ADD")
	APHMainFrame.Mini:Hide()
	APHMainFrame.Mini:SetScript("OnEnter", function() APHMainFrame.Mini:Show() end)
	APHMainFrame.Mini:SetScript("OnMouseUp", function() APH:Minimize() end)

	
	
	
local APHInfoFrame = CreateFrame("Frame", "ArtifactInfoFrame", ArtifactPowerFrame)
		APHInfoFrame:SetSize(220,40)
		APHInfoFrame:SetPoint("TOPLEFT", ArtifactPowerFrame)
		APHInfoFrame.CurAp= APHInfoFrame:CreateFontString("CurrentAP","ARTWORK","NumberFontNormal")
		APHInfoFrame.CurAp:SetFont("Fonts\\FRIZQT__.TTF", 10)
		APHInfoFrame.CurAp:SetJustifyH("CENTER")
		APHInfoFrame.CurAp:SetPoint("TOPLEFT")
		APHInfoFrame.CurAp:SetWidth(73)
		APHInfoFrame.ItemsAP= APHInfoFrame:CreateFontString("TotalItemsAP","ARTWORK","NumberFontNormal")
		APHInfoFrame.ItemsAP:SetFont("Fonts\\FRIZQT__.TTF", 10)
		APHInfoFrame.ItemsAP:SetJustifyH("CENTER")
		APHInfoFrame.ItemsAP:SetPoint("TOPLEFT",73,0)
		APHInfoFrame.ItemsAP:SetWidth(74)
		APHInfoFrame.RemainingAP= APHInfoFrame:CreateFontString("RemainingAP","ARTWORK","NumberFontNormal")
		APHInfoFrame.RemainingAP:SetFont("Fonts\\FRIZQT__.TTF", 10)
		APHInfoFrame.RemainingAP:SetJustifyH("CENTER")
		APHInfoFrame.RemainingAP:SetPoint("TOPLEFT",147,0)
		APHInfoFrame.RemainingAP:SetWidth(73)


function APH:UpdateTexts()
if self.db.char.ArtifactWeapons[Equipped] then
--self.db.char.ArtifactWeapons[Equipped]={CurRank or 0,CurPow or 0,CostOfNext or 0}
end
APHInfoFrame.CurAp:SetText("Current\n"..BreakUpLargeNumbers(CurPow))
APHInfoFrame.ItemsAP:SetText("Items\n"..BreakUpLargeNumbers(TotalArtifactPower)) --.. "/" .. BreakUpLargeNumbers( (CostOfNext or 0) - (CurPow or 0) ) )
APHInfoFrame.RemainingAP:SetText("Remaining\n"..BreakUpLargeNumbers(CostOfNext - CurPow))
end	
	
local APHItemFrame = CreateFrame("Frame", "ArtifactItemFrame", ArtifactPowerFrame)
	APHItemFrame:SetPoint("BOTTOMLEFT", ArtifactInfoFrame,"BOTTOMLEFT",0,0)
	APH:CreateArtifactItems()
	APH:CreateWeaponsIcons()

local APHMinimizedFrame = CreateFrame("Frame","APHMinimizedFrame", UIParent)
	APHMinimizedFrame:SetSize(64,64)
	APHMinimizedFrame:SetPoint("TOPLEFT", ArtifactPowerFrame)--,-54,0)
	APHMinimizedFrame:SetFrameStrata("BACKGROUND")
	APHMinimizedFrame.texture = APHMinimizedFrame:CreateTexture(nil, "BACKGROUND")
	--APHMinimizedFrame.texture:SetColorTexture(0,0,0,.5)
	APHMinimizedFrame.texture:SetAllPoints()
    APHMinimizedFrame:SetMovable(true)
    APHMinimizedFrame:SetClampedToScreen(true)
	APHMinimizedFrame:SetDontSavePosition(true)
	APHMinimizedFrame:EnableMouse(true)
	APHMinimizedFrame:RegisterForDrag("LeftButton")
	APHMinimizedFrame:SetScript("OnDragStart", APHMainFrame.StartMoving)
	APHMinimizedFrame:SetScript("OnDragStop", function () APH:StopMoving() end)
	
	
	APHMinimizedFrame.Icon = CreateFrame("Button","MinimizedWeapon",APHMinimizedFrame,"SecureActionButtonTemplate")
	APHMinimizedFrame.Icon:SetSize(36,36)
	APHMinimizedFrame.Icon.Texture=APHMinimizedFrame.Icon:CreateTexture(nil,"BACKGROUND")
	APHMinimizedFrame.Icon.Texture:SetAllPoints()
	APHMinimizedFrame.Icon:SetPoint("CENTER",APHMinimizedFrame)
	APHMinimizedFrame.Icon:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
	APHMinimizedFrame.Icon:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]],"ADD")
	APHMinimizedFrame.Icon.Percent = APHMinimizedFrame.Icon:CreateFontString("Percent","ARTWORK","NumberFontNormal")
	APHMinimizedFrame.Icon.Percent:SetFont("Fonts\\FRIZQT__.TTF", 10, "THICKOUTLINE")
	APHMinimizedFrame.Icon.Percent:SetJustifyH("CENTER")
	APHMinimizedFrame.Icon.Percent:SetJustifyV("MIDDLE")
	APHMinimizedFrame.Icon.Percent:SetPoint("CENTER",2,0)
	APHMinimizedFrame.Icon:SetScript("OnEnter", function() APHMinimizedFrame.Maxi:Show() end)
	APHMinimizedFrame.Icon:SetScript("OnLeave", function() APHMinimizedFrame.Maxi:Hide() end)

	if msqGroups["APHWeapons"] then msqGroups.APHWeapons:AddButton(APHMinimizedFrame.Icon) end

	APHMinimizedFrame.Maxi = CreateFrame("Button","APHMaximize",APHMinimizedFrame,"SecureActionButtonTemplate")
	APHMinimizedFrame.Maxi:SetSize(24,24)
	APHMinimizedFrame.Maxi.Texture=APHMinimizedFrame.Maxi:CreateTexture(nil,"BACKGROUND")
	APHMinimizedFrame.Maxi.Texture:SetAllPoints()
	APHMinimizedFrame.Maxi:SetPoint("TOPRIGHT",APHMinimizedFrame,14,0)
	APHMinimizedFrame.Maxi:SetNormalTexture([[Interface\Buttons\UI-Panel-BiggerButton-Up]])
	APHMinimizedFrame.Maxi:SetPushedTexture([[Interface\Buttons\UI-Panel-BiggerButton-Down]])
	APHMinimizedFrame.Maxi:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]],"ADD")
	APHMinimizedFrame.Maxi:SetScript("OnEnter", function() APHMinimizedFrame.Maxi:Show() end)
	APHMinimizedFrame.Maxi:SetScript("OnMouseUp", function() APH:Minimize() end)
	APHMinimizedFrame.Maxi:Hide()
	
	APHMinimizedFrame:SetScript("OnEnter", function() APHMinimizedFrame.Maxi:Show() end)
	APHMinimizedFrame:SetScript("OnLeave", function() APHMinimizedFrame.Maxi:Hide() end)
	APHMinimizedFrame:SetHitRectInsets(0, -14, 0, 0)

	APHMinimizedFrame:Hide()


